package apap.tutorial.belajarbelajar.controller;

import apap.tutorial.belajarbelajar.model.CourseModel;
import apap.tutorial.belajarbelajar.model.PengajarModel;
import apap.tutorial.belajarbelajar.model.PenyelenggaraModel;
import apap.tutorial.belajarbelajar.service.CourseService;
import apap.tutorial.belajarbelajar.service.PengajarService;
import apap.tutorial.belajarbelajar.service.PenyelenggaraService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;
import java.time.LocalDateTime;

import java.util.List;
import java.util.*;


@Controller
public class CourseController {
    @Qualifier("courseServiceImpl")
    @Autowired
    private CourseService courseService;

    @Autowired
    private PenyelenggaraService penyelenggaraService;

    @Autowired
    private PengajarService pengajarService;

    @GetMapping("/course/add")
    public String addCourseFormPage(Model model) {
        CourseModel course = new CourseModel();
        List<PenyelenggaraModel> listPenyelenggara = penyelenggaraService.getListPenyelenggara();
        List<PenyelenggaraModel> listPenyelenggaraNew = new ArrayList<>();
        List<PengajarModel> listPengajar = pengajarService.getListPengajar();
        List<PengajarModel> listPengajarNew = new ArrayList<>();

        course.setListPenyelenggara(listPenyelenggaraNew);
        course.getListPenyelenggara().add(new PenyelenggaraModel());
        course.setListPengajar(listPengajarNew);
        course.getListPengajar().add(new PengajarModel());

        model.addAttribute("course", course);
        model.addAttribute("listPenyelenggaraExisting", listPenyelenggara);
        model.addAttribute("listPengajarExisting", listPengajar);
        return "form-add-course";
    }

    @PostMapping(value = "/course/add", params = {"addRow"})
    public String addRowPenyelenggaraMultiple(@ModelAttribute CourseModel course, Model model) {
        if(course.getListPenyelenggara() == null || course.getListPenyelenggara().size() == 0){
            course.setListPenyelenggara(new ArrayList<>());
        }

        if (course.getListPengajar() == null || 0 == course.getListPengajar().size()) {
            course.setListPengajar((new ArrayList<>()));
        }        

        course.getListPenyelenggara().add(new PenyelenggaraModel());
        List<PenyelenggaraModel> listPenyelenggara = penyelenggaraService.getListPenyelenggara();
        List<PengajarModel> listPengajar = pengajarService.getListPengajar();

        model.addAttribute("course", course);
        model.addAttribute("listPenyelenggaraExisting", listPenyelenggara);
        model.addAttribute("listPengajarExisting", listPengajar);

        return "form-add-course";
    }

    @PostMapping(value="/course/add", params={"addRow2"})
    private String addRowPenyelenggaraMultiple2(
        @ModelAttribute CourseModel course,
        Model model
    ) {
        if (course.getListPenyelenggara() == null || course.getListPenyelenggara().size() == 0) {
            course.setListPenyelenggara((new ArrayList<>()));
        }
        if (course.getListPengajar() == null || course.getListPengajar().size() == 0) {
            course.setListPengajar((new ArrayList<>()));
        }
        course.getListPengajar().add(new PengajarModel());
        
        List<PenyelenggaraModel> listPenyelenggara = penyelenggaraService.getListPenyelenggara();
        List<PengajarModel> listPengajar = pengajarService.getListPengajar();

        model.addAttribute("course", course);
        model.addAttribute("listPenyelenggaraExisting", listPenyelenggara);
        model.addAttribute("listPengajarExisting", listPengajar);

        return "form-add-course";
    }

    @PostMapping(value = "/course/add", params = {"deleteRow"})
    public String deleteRowPenyelenggaraMultiple(@ModelAttribute CourseModel course, 
                                                 @RequestParam("deleteRow") Integer row,
                                                    Model model) {
        final Integer rowId = Integer.valueOf(row);
        course.getListPenyelenggara().remove(rowId.intValue());

        List<PenyelenggaraModel> listPenyelenggara = penyelenggaraService.getListPenyelenggara();
        List<PengajarModel> listPengajar = pengajarService.getListPengajar();

        model.addAttribute("course", course);
        model.addAttribute("listPenyelenggaraExisting", listPenyelenggara);
        model.addAttribute("listPengajarExisting", listPengajar);

        return "form-add-course";
    }

    @PostMapping(value="/course/add", params={"deleteRow2"})
    private String deleteRowPenyelenggaraMultiple2(
        @ModelAttribute CourseModel course,
        @RequestParam("deleteRow2") Integer row,
        Model model
    ) {
        final Integer rowId = Integer.valueOf(row);
        course.getListPengajar().remove(rowId.intValue());

        List<PenyelenggaraModel> listPenyelenggara = penyelenggaraService.getListPenyelenggara();
        List<PengajarModel> listPengajar = pengajarService.getListPengajar();

        model.addAttribute("course", course);
        model.addAttribute("listPenyelenggaraExisting", listPenyelenggara);
        model.addAttribute("listPengajarExisting", listPengajar);

        return "form-add-course";
    }
    
    @PostMapping(value = "/course/add", params={"save"})
    public String addCourseSubmitPage(@ModelAttribute CourseModel course, Model model) {
        if (course.getListPenyelenggara() == null){
            course.setListPenyelenggara(new ArrayList<>());
        }

        List<PengajarModel> listPengajar = course.getListPengajar();
        for (PengajarModel pengajarModel : listPengajar) {
            pengajarModel.setCourse(course);
        }     

        courseService.addCourse(course);
        model.addAttribute("code", course.getCode());
        return "add-course";
    }

    @GetMapping("/course/viewall")
    public String listCourse(Model model) {
        List<CourseModel> listCourse = courseService.getListCourse();
        model.addAttribute("listCourse", listCourse);
        return "viewall-course";
    }

    @GetMapping("/course/view")
    public String viewDetailCoursePage(@RequestParam(value = "code") String code, Model model) {
        CourseModel course = courseService.getCourseByCodeCourse(code);

        if(course != null){
            List<PengajarModel> listPengajar = course.getListPengajar();
            List<PenyelenggaraModel> listPenyelenggara = course.getListPenyelenggara();
            model.addAttribute("listPenyelenggara", listPenyelenggara);            
            model.addAttribute("listPengajar", listPengajar);
            model.addAttribute("course", course);
            return "view-course";
        }
        else {
            return "fail-view-course";
        }
    }

    @GetMapping("/course/view-query")
    public String viewDetailCoursePageQuery(@RequestParam(value = "code") String code, Model model) {
     
        CourseModel course = courseService.getCourseByCodeCourseQuery(code);
        List<PengajarModel> listPengajar = course.getListPengajar();
        model.addAttribute("listPengajar", listPengajar);
        model.addAttribute("course", course);

        return "view-course";
    }

    @GetMapping("/course/update/{code}")
    public String updateCourseFormPage(@PathVariable String code, Model model) {
        if (courseService.getCourseByCodeCourse(code) == null) {
            model.addAttribute("code", code);
            return "fail-view-course";
        }        

        CourseModel course = courseService.getCourseByCodeCourse(code);
        model.addAttribute("course", course);

        return "form-update-course";
    }

    @PostMapping("/course/update")
    public String updateCourseSubmitPage(@ModelAttribute CourseModel course, Model model) {
        CourseModel updatedCourse = courseService.updateCourse(course);
        model.addAttribute("code", updatedCourse.getCode());

        return "update-course";
    }
    @GetMapping("/course/view/{code}/deletecourse")
    public String deleteCourse(@PathVariable(value = "code")String code, Model model) {
        if (courseService.getCourseByCodeCourse(code) == null) {
            model.addAttribute("code", code);
            return "fail-view-course";
        }

        CourseModel course = courseService.getCourseByCodeCourse(code);
        List<PengajarModel> listPengajar = course.getListPengajar();
        if(listPengajar.isEmpty() && (LocalDateTime.now().isAfter(course.getTanggalBerakhir())) || LocalDateTime.now().isBefore(course.getTanggalDimulai())){
            courseService.deleteCourse(course);
            model.addAttribute("code", course.getCode());
            return "delete-course";
        } else {
            return "gagal-delete-course";
        }
        
    }
}
