package apap.tutorial.belajarbelajar.controller;

import java.time.LocalDateTime;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;

import apap.tutorial.belajarbelajar.model.CourseModel;
import apap.tutorial.belajarbelajar.model.PengajarModel;
import apap.tutorial.belajarbelajar.service.CourseService;
import apap.tutorial.belajarbelajar.service.PengajarService;

@Controller
public class LatihanController {
    @Qualifier("courseServiceImpl")
    @Autowired
    private CourseService courseService; 
    @Qualifier("pengajarServiceImpl")
    @Autowired
    private PengajarService pengajarService; 
    
    //latihan no 2
    @GetMapping("/pengajar/update/{noPengajar}")
    public String updatePengajarFormPage(@PathVariable Long noPengajar, Model model) {
        PengajarModel pengajar = pengajarService.getPengajarByNoPengajar(noPengajar);

        LocalDateTime sekarang = LocalDateTime.now();

        if (sekarang.isAfter(pengajar.getCourse().getTanggalBerakhir())){
            model.addAttribute("pengajar", pengajar);
            return "form-update-pengajar";

        }
        else {
            return "gagal-update-pengajar";
        }

        
    }
    // latihan no 2
    @PostMapping("/pengajar/update")
    public String updatePengajarSubmitPage(@ModelAttribute PengajarModel pengajar, Model model) {
       PengajarModel updatedPengajar = pengajarService.updatePengajar(pengajar);
        model.addAttribute("noPengajar", updatedPengajar.getNoPengajar());

        return "update-pengajar";
    }

    // latihan no 4
    @GetMapping("/course/delete/{code}")
    public String deleteCourse(@PathVariable String code, Model model){
        CourseModel course = courseService.getCourseByCodeCourse(code);
        LocalDateTime sekarang = LocalDateTime.now();

        if ((sekarang.isBefore(course.getTanggalBerakhir()) && sekarang.isAfter(course.getTanggalDimulai())) || course.getListPengajar().size() != 0){
            return "gagal-delete-course";
        }
        else {
            courseService.deleteCourse(course);
            return "delete-course";
        }
        
    }


}
