package apap.tutorial.belajarbelajar.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.context.SecurityContextHolder;

import apap.tutorial.belajarbelajar.model.RoleModel;
import apap.tutorial.belajarbelajar.model.UserModel;
import apap.tutorial.belajarbelajar.service.RoleService;
import apap.tutorial.belajarbelajar.service.UserService;

@Controller
@RequestMapping("/user")
public class UserController {
  @Autowired
  private UserService userService;

  @Autowired
  private RoleService roleService;

  @GetMapping(value="/add")
  private String addUserFormPage(Model model) {
    UserModel user = new UserModel();
    List<RoleModel> listRole = roleService.findAll();
    model.addAttribute("user", user);
    model.addAttribute("listRole", listRole);
    return "form-add-user";
  }

  @PostMapping(value="/add")
  private String addUserSubmit(@ModelAttribute UserModel user, Model model) {
    user.setIsSso(false);
    userService.addUser(user);
    model.addAttribute("user", user);
    return "redirect:/";
  }

  @GetMapping("/viewall")
  public String listUser(Model model) {
      List<UserModel> listUser = userService.findAll();
      Authentication autentikasi = SecurityContextHolder.getContext().getAuthentication();
      User user = (User) autentikasi.getPrincipal();
      String username = user.getUsername();
      UserModel userModel = userService.getUserByUsername(username);
      model.addAttribute("listUser", listUser);
      model.addAttribute("user", userModel);
      return "viewall-user";
  }

  @GetMapping("/update-password")
  public String updatePasswordFormPage() {
      return "form-update-password";
  }
  
  @PostMapping("/update-password")
  public String updatePasswordSubmitPage(
    @ModelAttribute UserModel userModel, String newPassword, String confirmPassword, Model model){
      UserModel user = userService.getUserByUsername(userModel.getUsername());
      BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
      if (passwordEncoder.matches(userModel.getPassword(), user.getPassword())){
          if(passwordEncoder.matches(newPassword, user.getPassword())){
            return "password-sama";
          }
          if (newPassword.equals(confirmPassword)){
              user.setPassword(newPassword);
              userService.addUser(user);
              return "update-password";
          } else {
              model.addAttribute("text", "Masukkan konfirmasi password yang sesuai.");
          }
      } else {
          model.addAttribute("text", "Masukkan password yang valid.");
      }
      return "form-update-password";
  } 

  @GetMapping("/delete/{username}")
  public String removeUser (@PathVariable String username, Model model) {
      UserModel user = userService.getUserByUsername(username);
      userService.deleteUser(user);
      model.addAttribute("user", user);
      return "delete-user";
  }
 
  
}